package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.diagbot.entity.QcModuleDetail;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.service.QcModuleDetailService;
import com.diagbot.service.impl.QcModuleDetailServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.DateUtil;
import com.diagbot.util.UserUtils;
import com.diagbot.vo.AddModuleDetailVO;
import com.diagbot.vo.AddModuleInfoVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:zhoutg
 * @time: 2018/11/23 11:37
 */
@Component
public class QcModuleDetailFacade extends QcModuleDetailServiceImpl {

    @Autowired
    private QcModuleInfoFacade moduleInfoFacade;
    @Autowired
    @Qualifier("qcModuleDetailServiceImpl")
    private QcModuleDetailService qcModuleDetailService;

    /**
     * 根据questionId删除明细
     *
     * @param map
     * @return
     */
    public void deleteByQuestionIdFac(Map map) {
        this.deleteByQuestionIds(map);
    }


    /**
     * 根据moduleId删除明细
     *
     * @param map
     * @return
     */
    public void deleteByModuleIdFac(Map map) {
        this.deleteByModuleIds(map);
    }

    /**
     * 添加模板明细
     *
     * @param addModuleInfoVO
     * @return
     */
    public Boolean saveOrUpdateInfos(AddModuleInfoVO addModuleInfoVO, Long moduleId) {
        String userId = UserUtils.getCurrentPrincipleID();
        Date now = DateUtil.now();
      //如果该模板添加过明细，先删除
        UpdateWrapper<QcModuleDetail> moduleDetailUpdateWrapper = new UpdateWrapper<>();
        moduleDetailUpdateWrapper.eq("is_deleted", IsDeleteEnum.N.getKey())
                .eq("module_id", moduleId)
                .set("is_deleted", IsDeleteEnum.Y.getKey())
                .set("modifier", userId)
                .set("gmt_modified", now);
        this.update(new QcModuleDetail(), moduleDetailUpdateWrapper);

        List<QcModuleDetail> moduleDetailList = new ArrayList<>();
        int i = 1;
        for (AddModuleDetailVO detailVO : addModuleInfoVO.getModuleDetail()) {
            QcModuleDetail qcModuleDetail = new QcModuleDetail();
            BeanUtil.copyProperties(detailVO, qcModuleDetail);
            qcModuleDetail.setOrderNo(i++);
            qcModuleDetail.setModuleId(moduleId);
            qcModuleDetail.setGmtCreate(now);
            qcModuleDetail.setGmtModified(now);
            qcModuleDetail.setCreator(userId);
            qcModuleDetail.setModifier(userId);
            moduleDetailList.add(qcModuleDetail);
        }
        //添加模板明细
        qcModuleDetailService.saveBatch(moduleDetailList);
        return true;
    }
}
