package com.diagbot.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.diagbot.dto.QcCasesEntryAllDTO;
import com.diagbot.dto.QcCasesEntryDTO;
import com.diagbot.entity.QcCasesEntry;
import com.diagbot.vo.QcCasesEntryAllVO;
import com.diagbot.vo.QcCasesEntryIndexVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 病历条目 Mapper 接口
 * </p>
 *
 * @author wangfeng
 * @since 2020-03-10
 */
public interface QcCasesEntryMapper extends BaseMapper<QcCasesEntry> {

    /**
     * 分页获取病例条目
     *
     * @param qcCasesEntryAllVO
     * @return
     */
    IPage<QcCasesEntryAllDTO> getAllQcCasesEntry(QcCasesEntryAllVO qcCasesEntryAllVO);

    IPage<QcCasesEntryAllDTO> getQcCasesEntryIndex(QcCasesEntryIndexVO qcCasesEntryIndexVO);

    List<QcCasesEntryDTO> getByCasesEntryId( @Param("ids") List<Long> ids);

    List<QcCasesEntryDTO> getQcCasesEntryAll();
}
